tempDir=getDir #temp
userRoot=getDir #maxData
maxRoot=getDir #maxRoot
copiedFiles=#()

pathConfig.isUsingProfileDirectories()

clearListener()
/*
Move files to the max dirs.
*/
fn copyFiles source dest overWriteExisting:true=
(
	files=getfiles (source+"\\*")
	for f in files do
	(
		fName=filenameFromPath f
		filePath=dest+"\\"+fName
		
		if doesFileExist filePath and overWriteExisting then
		(
			deleteFile filePath
		)
		didCopy=copyFile f filePath
		format "Copied: % \tFile: %\n" didCopy filePath
		if didCopy then append copiedFiles filePath
	)
	copiedFiles
)

fn copyDirectoriesRecursive source dest includeFiles:true overWriteExisting:true=
(
	dirs=getDirectories (source+"\\*")
	for d in dirs do
	(
		dirs=filterstring d "\\"
		dir=dirs[dirs.count]
		destPath=(dest+"\\"+dir)
		didMake=makeDir destPath
		format "Created: % \tDirectory: %\n" didMake destPath

		if includeFiles then
		(
			copyFiles d destPath overWriteExisting:overWriteExisting
		)
		copyDirectoriesRecursive d destPath includeFiles:includeFiles overWriteExisting:overWriteExisting
	)
)

fn copyDirectories source dest recursive:true includeFiles:true overWriteExisting:true=
(
	if doesFileExist source and doesFileExist dest then
	(
		dirs=filterstring source "\\"
		dir=dirs[dirs.count]
		destPath=(dest+"\\"+dir)
		didMake=makeDir destPath
		format "Created: % \tDirectory: %\n" didMake destPath
		
		if didMake and includeFiles then
		(
 			copyFiles source destPath overWriteExisting:overWriteExisting
		)
		if didMake and recursive then
		(
			copyDirectoriesRecursive source destPath includeFiles:includeFiles overWriteExisting:overWriteExisting
		)
	)
)

copyDirectories (tempDir+"\\PEN_Animation") maxRoot recursive:true includeFiles:true overWriteExisting:true
copyDirectories (tempDir+"\\plugcfg") userRoot recursive:true includeFiles:true overWriteExisting:true
copyDirectories (tempDir+"\\plugins") maxRoot recursive:true includeFiles:true overWriteExisting:true
copyDirectories (tempDir+"\\scripts") maxRoot recursive:true includeFiles:true overWriteExisting:true
copyDirectories (tempDir+"\\UI") maxRoot recursive:true includeFiles:true overWriteExisting:true

/*
Execute files on system. 
*/
for f in copiedFiles do
(
	try
	(
		fileIn f
		format "File Run: %\n" f
	)catch
	(
	)
)

/*
Delete temp files. 
*/
dIO=dotNetClass "system.IO.directory"
for d in (getDirectories (tempDir+"\\*")) do
(
	dIO.delete d true
)

/*
Manual cleanup
Delete files from system that are not needed. 
*/
deleteList=#
(
	(maxRoot + "\\runMxDriver2.mse"),
	(maxRoot + "\\run.ms"),
	(tempDir + "\\mzp.run")
)
for f in deleteList do
(
	if (doesFileExist f) then
	(
		deleteFile f
		format "Deleted: % from system.\n" f
	)
)


format "PEN Objects Installer \n\tInstallation complete!\n"

